SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!
SystemOrganization addCategory: #'MemoryMentor-Visualization'!
SystemOrganization addCategory: #'MemoryMentor-Core'!

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Morph subclass: #MMMemoryAddressMorph
	instanceVariableNames: 'address stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryAddressMorph class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:57:57.018'!
forAddress: anInteger width: width height: height
	^ self new
		address: anInteger;
		initializeWithWidth: width height: height;
		yourself! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:58:21.63'!
address
	^ address! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:55.924'!
address: anInteger
	address := anInteger.
	
	self updateStringMorph! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:33.592'!
addressString
	 ^ '0x', (address printStringBase: 16)! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:03:18.186'!
initializeWithWidth: width height: height
	super initialize.
	
	stringMorph := StringMorph new.
	
	self color: Color white;
		extent: width@height;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center;
		addMorph: stringMorph.
	
	self updateStringMorph! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:03:39.056'!
updateStringMorph
	stringMorph ifNil: [ ^ self ].
	
	stringMorph contents: self addressString! !

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryMorph commentStamp: 'lt 5/13/2013 14:49:41.125' prior: 0!
(MMMemoryMorph for: (MMMemory withStartAddress: 16r100 bytes:  #[104 101 108 108 111] cellCount: 20)) openInHand!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:06:09.758'!
initialize
	super initialize.
	
	self
		color: Color red;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		"listDirection: #topToBottom;
		wrapDirection: #leftToRight;"
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:44:34.642'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell |
		self addMorphBack: (MMCellGroupMorph for: cell).
	].
	self extent: self fullBounds extent.! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 14:38:36.112'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu"
	^ false! !

Morph subclass: #MMRightAngledArrow
	instanceVariableNames: 'from to spacing arrowBorderWidth points horizontalLungeDirection verticalLungeDirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:15:01.562'!
from: aPoint to: anotherPoint
	^ self new
		initializeFrom: aPoint to: anotherPoint;
		yourself! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:41:07.756'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v := endPoint - priorPoint.
	angle := v degrees.
	d := arrowBorderWidth max: 1.
	arrowSpec := self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length := arrowSpec x abs.  width := arrowSpec y abs.
	wingBase := endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:47:34.906'!
bottomLunge
	^ 0 @ -1! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:46:08.27'!
drawArrowOn: canvas
	self assert: [ points size >= 2].
	
	points overlappingPairsDo:[ :p1 :p2 |
		canvas line: p1 to: p2 width: arrowBorderWidth color: Color black
	].
	canvas
		drawPolygon: (self arrowBoundsAt: points last from: (points at: points size - 1))
		color: Color white borderWidth: arrowBorderWidth borderColor: Color black! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:35:45.466'!
drawOn: aCanvas
	aCanvas
		translateBy: self owner position
		during: [ :canvas | self drawArrowOn: canvas ].! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:43:26.524'!
initialize
	super initialize.
	
	arrowBorderWidth := 2.
	spacing := 30.
	points := OrderedCollection new.
	horizontalLungeDirection := #left.
	verticalLungeDirection := #top! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:46:42.314'!
initializeFrom: aPoint to: anotherPoint
	| bounds |
	self assert: [ aPoint ~= anotherPoint ].
	
	from := aPoint.
	to := anotherPoint.
	self initializeLines.
	bounds := from rect: to.
	points do: [ :point | bounds := bounds encompass: point ].
	(self arrowBoundsAt: points last from: (points at: points size - 1)) do: [ :point | bounds := bounds encompass: point ].
	self bounds: (bounds outsetBy: arrowBorderWidth)! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:07:48.778'!
initializeLines
	points := OrderedCollection new.
	
	points add: from.
	
	true caseOf: {
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs >= spacing ] ] -> [
			(from x - to x) abs > (from y - to y) abs ifTrue: [
				points add: from x @ (from interpolateTo: to at: 0.5) y.
				points add: to x @ (from interpolateTo: to at: 0.5) y.
			] ifFalse: [
				points add: (from interpolateTo: to at: 0.5) x @ from y.
				points add: (from interpolateTo: to at: 0.5) x @ to y.
			]
		].
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs < spacing ] ] -> [ | tempY |
			tempY := verticalLungeDirection == #top ifTrue: [ (from y max: to y) + spacing ] ifFalse: [ (from y min: to y) - spacing ].
			points add: from x @ tempY.
			points add: to x @ tempY
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs >= spacing ] ] -> [ | tempX |
			tempX := horizontalLungeDirection == #left ifTrue: [ (from x min: to x) - spacing ] ifFalse: [ (from x max: to x) + spacing ].
			points add: tempX @ from y.
			points add: tempX @ to y
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs < spacing ] ] -> [
			"straight line, so add no points"
		]
	}.
	
	points add: to! !

Morph subclass: #MMToolTippedMorph
	instanceVariableNames: 'tooltip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

MMToolTippedMorph subclass: #MMCellGroupMorph
	instanceVariableNames: 'cells type displayMode container valueMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:12:07.924'!
byteHeight
	^ TextStyle default defaultFont height + 5! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:11:09.818'!
byteWidth
	^ (TextStyle default defaultFont widthOf: $0) * (8+4)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:43:54.146'!
defaultDisplayMode
	^ #hexadecimal
	! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:15:05.714'!
defaultWidth
	^ self byteWidth * 4! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:44:05.178'!
displayModes
	^ #(ascii binary decimal hexadecimal pointer)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:53:10.932'!
for: cellOrCells
	 ^ self new
		cells:
			(cellOrCells isCollection
				ifTrue: [ cellOrCells ]
				ifFalse: [ Array with: cellOrCells ]);
		setup! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:46:38.254'!
cells
	 ^ cells! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:46:28.012'!
cells: aCellCollection
	cells := aCellCollection! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:44:23.618'!
createAddressMorph
	| width labelMorph |
	width := (TextStyle default defaultFont widthOf: $0) * 
			(('0x', (cells first memory endAddress printStringBase: 16)) size + 1).
	labelMorph := MMMemoryAddressMorph forAddress: cells first address width: width height: self class byteHeight .
	self updateTooltipWith: labelMorph addressString.
	^ labelMorph! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:54:25.152'!
createByteMorph: i of: cell
	^ MMValueMorph new
		extent: (self class byteWidth @ self class byteHeight);
		color: (Color gray: 0.9);
		displayMode: displayMode;
		value: (cell byteAt: i);
		layoutPolicy: TableLayout new;
		listDirection: #lefttoRight;
		listCentering: #center;
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:49:46.454'!
createByteMorphs
	| byteMorphs |
	byteMorphs := OrderedCollection new.
	cells do: [ :cell | 1 to: 4 do: [ :i | (byteMorphs add: (self createByteMorph: i - 1 of: cell)) ] ].
	^ byteMorphs! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:44:28.75'!
displayMode: aSymbol
	(self class displayModes includes: aSymbol) ifFalse:
		[ self error: 'DisplayMode ', aSymbol asString, ' not supported'].
	
	displayMode := aSymbol.
	
	self displayModeChanged! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:57:33.27'!
displayModeChanged
	valueMorphs do: [ :valueMorph | valueMorph displayMode: displayMode ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:58:03.366'!
initialize 
	super initialize.
	valueMorphs := OrderedCollection new.
	container := Morph new
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left;
		yourself.
	self
		displayMode: self class defaultDisplayMode;
		color: Color white;
		wantsYellowButtonMenu: true;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left.! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:41:57.098'!
openMenu
	| menu formatMenu |
	formatMenu := MenuMorph new
		add: 'Binary' target: self selector: #displayMode: argument: #binary;
		add: 'Decimal' target: self selector: #displayMode: argument: #decimal;
		add: 'Hexadecimal' target: self selector: #displayMode: argument: #hexadecimal;
		add: 'ASCII' target: self selector: #displayMode: argument: #ascii;
		add: 'Pointer' target: self selector: #displayMode: argument: #pointer;
		yourself.
	
	menu := MenuMorph new.
	menu add: 'Interpret as ...' subMenu: formatMenu.
	
	menu popUpInWorld.! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:57:01.008'!
setup
	self
		addMorphBack: self createAddressMorph;
		addMorphBack: container.
		
	valueMorphs := self createByteMorphs.
	container addMorphs: valueMorphs.
		
	self extent: self fullBounds extent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 14:35:39.516'!
yellowButtonActivity: shiftKeyState
	self openMenu.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:06:17.438'!
createTooltip
	tooltip := BorderedMorph new.
	tooltip
		color: Color yellow muchLighter paler;
		borderWidth: 1.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:03:13.85'!
handlesMouseMove: event
	^ true! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:32.461'!
hideTooltip
	tooltip delete.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:21.123'!
initialize
	super initialize.
	self 
		createTooltip;
		initializeEvents.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:29.41'!
initializeEvents
	self on: #mouseEnter send: #mouseEnter to: self.
	self on: #mouseMove send: #moveTooltip to: self.
	self on: #mouseLeave send: #mouseLeave to: self.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:19.744'!
mouseEnter
	self addAlarm: #showTooltip after: 1000.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:09.543'!
mouseLeave
	self removeAlarm: #showTooltip.
	self hideTooltip.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:51.349'!
moveTooltip
	tooltip position: ActiveHand center.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:25.524'!
showTooltip
	tooltip position: ActiveHand center.
	World addMorph: tooltip.
	tooltip fadeIn.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:24.159'!
updateTooltipWith: aMessage
	tooltip
		removeAllMorphs;
		addMorph: (StringMorph new contents: aMessage; yourself);
		bounds: tooltip fullBounds.! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAddress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:14.594'!
withStartAddress: startAddress bytes: aByteArray

	^ self 
		withStartAddress: startAddress 
		bytes: aByteArray 
		cellCount: (aByteArray size / 4) ceiling! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:30.614'!
withStartAddress: startAddress bytes: aByteArray cellCount: aNumber
	|instance|
	instance := self withStartAddress: startAddress cellCount: aNumber.
	instance at: startAddress putByteArray: aByteArray.
	^ instance! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:17:01.288'!
withStartAddress: startAddress cellCount: aNumber
	^ self new
		initializeWithStartAddress: startAddress cellCount: aNumber;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:29.536'!
= anotherMMMemory
	self class == anotherMMMemory class ifFalse: [ ^ false ].
	startAddress == anotherMMMemory startAddress ifFalse: [ ^ false ].
	
	^ memory = anotherMMMemory memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:31:02.124'!
at: address putByte: byte
	memory byteAt: (self indexForAddress: address) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:27:13.602'!
at: address putByteArray: byteArray
	(byteArray size > (cells size * 4) ifTrue: [ byteArray first: cells size * 4 ] ifFalse: [ byteArray ])
		withIndexDo: [ :byte :index |
		self at: address+index-1 putByte: (byteArray at: index)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:11.56'!
at: address putInt: int
	memory intAt: (self indexForAddress: address) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:25:05.046'!
byteAt: adress
	 ^ memory at: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:14:26.12'!
cellAtAddress: address
	^ cells at: (self cellIndexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:43.905'!
cellCount
	^ cells size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:13:45.782'!
cellIndexForAddress: address
	^ ((address roundDownTo: 4) - startAddress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:54:00.067'!
endAddress
	^ startAddress + (self cellCount * MMMemoryCell size)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:46.656'!
indexForAddress: address
	^ address - startAddress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:16:31.907'!
initializeWithStartAddress: adress cellCount: aNumber
	startAddress := adress.
	memory := ByteArray new: aNumber*4.
	cells := OrderedCollection new.
	1 to: aNumber do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAddress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:31.124'!
intAt: address
	 ^ memory intAt: (self indexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:06.59'!
memory
	^ memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:09.978'!
startAddress
	^ startAddress! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'address memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:46.536'!
at: address in: memory
	 ^ self new
		initializeWithAddress: address andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:11.996'!
address
	^ address! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:22:27.266'!
byteAt: index
	^ memory byteAt: address + index! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:28.346'!
initializeWithAddress: anAddress andMemory: aMemory
	address := anAddress.
	memory := aMemory! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:00.459'!
memory
	^ memory! !

TestCase subclass: #MMMemoryCellTest
	instanceVariableNames: 'memory startAddress size cell address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:41:45.706'!
setUp
	startAddress := 16r1000.
	address := startAddress + 4.
	memory := MMMemory withStartAddress: startAddress bytes: #(1 2 3 4 5 6 7 8 9 10 11 12).
	
	cell := MMMemoryCell at: address in: memory! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:42:31.55'!
testAccess
	self assert: [ (cell byteAt: 0) == 5 ].
	self assert: [ (cell byteAt: 1) == 6 ].
	self assert: [ (cell byteAt: 2) == 7 ].
	self assert: [ (cell byteAt: 3) == 8 ].! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:45:00.558'!
testInitialization
	self assert: [ cell address == address ].
	self assert: [ cell memory == memory ]! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAddress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:01:05.856'!
setUp
	startAddress := 4096.
	size := 4.
	memory := MMMemory withStartAddress: startAddress cellCount: size! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:09:14.552'!
testByteData
	memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	
	1 to: size * 4 do: [ :index |
		self assert: [ (memory byteAt: (index - 1 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:06:38.408'!
testCellAccess
	self shouldnt: [ memory cellAtAddress: startAddress + 4 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 4) address == (startAddress + 4) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 12 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 12) address == (startAddress + 12) ].
	
	self should: [ memory cellAtAddress: startAddress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAddress: startAddress + (size * 4) ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:07:50.83'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell address == (4*cellIndex + startAddress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == size ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:27:44.958'!
testEquality
	| secondMemory bytes |
	
	bytes := #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	memory at: startAddress putByteArray: bytes.
	secondMemory := MMMemory withStartAddress: startAddress bytes: bytes.
	
	self assert: [ memory = secondMemory ].! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:11:49.834'!
testInitialization
	self assert: [ memory startAddress == startAddress ].
	self assert: [ memory cellCount == size ].
	self assert: [ memory byteSize == (size * MMMemoryCell size)].
	self assert: [ memory endAddress == (startAddress + (4 * size)) ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:10:07.36'!
testIntegerData
	memory at: startAddress putInt: 1.
	memory at: startAddress+4 putInt: 2.
	memory at: startAddress+8 putInt: 3.
	memory at: startAddress+12 putInt: 4.
	
	1 to: size do: [ :index |
		self assert: [ (memory intAt: (index - 1 * 4 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:05:30.808'!
testLongData
	self shouldnt: [ memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20) ] raise: Exception.
	self assert: [ memory cellCount == size ]! !

BorderedMorph subclass: #MMValueMorph
	instanceVariableNames: 'value displayMode stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMValueMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:30:30.952'!
displayModes
	^ #(ascii binary decimal hexadecimal)! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:34:39.726'!
displayMode
	 ^ displayMode! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:35:34.384'!
displayMode: aSymbol
	(self class displayModes includes: aSymbol)
		ifFalse: [ self error: 'invalid display mode' ].
	displayMode := aSymbol.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:39:05.124'!
initialize 
	super initialize.
	displayMode := #decimal.
	value := 0.
	stringMorph := StringMorph new.
	self addMorph: stringMorph.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:39:17.134'!
updateValueString
	stringMorph contents: self valueString! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:32:53.034'!
value
	^ value! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:33:37.134'!
value: anInteger
	value := anInteger.
	self updateValueString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:37:28.718'!
valueString
	^ displayMode caseOf: {
		[ #decimal ] -> [ value printString ].
		[ #binary ] -> [ ((value printStringBase: 2) padded: #left to: 8 with: $0), 'b' ].
		[ #hexadecimal ] -> [ '0x', (value printStringBase: 16) padded: #left to: 2 with: $0 ].
		[ #ascii ] ->[ value >= 32
				ifTrue:[ (Character value: value) asString printString ]
				ifFalse: [ ('\', value asString) printString ] ].
	}! !
